#include <iostream>
#include <unordered_map>
#include <tuple>
#include <utility>
#include <vector>
using namespace std;

int main() {
    int X, N;
    cin >> X >> N;
    vector<int> A(N+3,0);
    for (int n=0; n<N; ++n) cin >> A[n];
    N += 3;
    
    unordered_multimap< int, pair<int,int> > seen;
    for (int i=0; i<N; ++i)
        for (int j=0; j<i; ++j) {
            seen.insert( { A[i]+A[j], {i,j} } );
            auto eqr = seen.equal_range( X-A[i]-A[j] );
            for (auto it=eqr.first; it!=eqr.second; ++it) {
                int k,l;
                tie(k,l) = it->second;
                if (i==k || i==l || j==k || j==l) continue;
                for (int x : {i,j,k,l}) if (A[x]) cout << A[x] << " ";
                return 0;
            }
        }
    
    cout << "Koniec sveta sa odklada\n";
}
