#include <iostream>
#include <unordered_set>
#include <utility>
#include <vector>
using namespace std;

int main() {
    int X, N;
    cin >> X >> N;
    vector<int> A(N+3,0);
    for (int &a:A) cin >> a;
    N += 3;

    unordered_set<int> SA(A.begin(),A.end());

    for (int kolo=0; kolo<2345678; ++kolo) {
        int i = rand()%N;
        int j = rand()%N;
        int k = rand()%N;
        if (i==j || i==k || j==k) continue;
        int treba = X - A[i] - A[j] - A[k];
        if (treba > 0 && (treba==A[i] || treba==A[j] || treba==A[k])) continue;
        if (SA.count(treba)) {
            for (int x : {A[i],A[j],A[k],treba}) if (x) cout << x << " ";
            return 0;
        }
    }
    cout << "Koniec sveta sa odklada\n";
}
